<?php // utf-8 check: äöü

if (!defined('CMSIMPLE_VERSION') || preg_match('#plugins/charts/admin.php#i', $_SERVER['SCRIPT_NAME']))
{
	die('no direct access');
}

/*
============================================================
CMSimple Plugin Charts
============================================================
Version:    Charts 2.2
Released:   2023-01
Copyright:  Gert Ebersbach
Internet:   www.ge-webdesign.de
Credit:     chartjs script - chartjs.org
============================================================ 
License: Commercial License (for commercial websites only)
see http://www.ge-webdesign.de/cmsimpleplugins/?Nutzungsbedingungen
============================================================ 
*/

initvar('charts');

if($charts)
{
	if(!defined('CMSIMPLE_VERSION'))
	{
		$o.= '<p>This plugin requires <b>CMSimple 4.2</b> or higher.</p><p><a href="http://www.cmsimple.org/">CMSimple Download & Updates &raquo;</a></p>';
		return;
	}
	
	if(defined('XH_ADM'))
	{
		$o.= '<div style="font-size: 15px; font-family: arial, sans-serif; letter-spacing: 0;">
<h4><a href="?charts">Plugin Info &raquo;</a></h4>
<p style="line-height: 1.6em;"><b>Charts</b>&nbsp;by&nbsp;<a href="http://www.ge-webdesign.de/cmsimpleplugins/"><u>ge-webdesign.de&nbsp;&raquo;</u></a> &nbsp; 
for&nbsp;<b>CMSimple&nbsp;4.0</b>&nbsp;or&nbsp;higher&nbsp;from&nbsp;<a href="http://www.cmsimple.org/"><u>cmsimple.org&nbsp;&raquo;</u></a></p>
</div>';
	}
	else
	{
		$o.= '<div style="font-size: 15px; font-family: arial, sans-serif; letter-spacing: 0; padding: 0 0 6px 0;">
<b><a href="?charts">Plugin Info &raquo;</a></b>
</div>
';
	}
	
	$plugin = 'charts';
	$o.= print_plugin_admin('on');
	
	if($admin=='')
	{
		$o.='
		<h4>Plugin Charts</h4>';
		
		$o .= '
		<div style="font-family: arial, sans-serif; font-size: 15px; letter-spacing: 0; border: 4px double; padding: 6px 16px; margin: 2px 0 8px 0;">
		<p style="text-align: center;">This Plugin is made for <a href="http://www.cmsimple.org/"><span style="font-weight: 700; padding: 0 6px; ">CMSimple 4.2 &raquo;</span></a> or higher.</p>
		<p style="text-align: center;">Optimized for <span style="font-weight: 700; padding: 0 6px; ">CMSimple 4.4</span> or higher.</p>
		<p style="text-align: center;">Recommended is the current version of CMSimple from <a href="http://www.cmsimple.org/">cmsimple.org&nbsp;&raquo;</a></p>
		</div>
		';
		
		$o.='<ul>
		<li>Version: Charts 2.2</li>
		<li>Released: 2023/01</li>
		<li>Copyright: Gert Ebersbach</li>
		<li>Credit: chartjs development team - <a href="https://chartjs.org/">chartjs.org</a></li>
		<li>Lizenz: <a href="http://www.ge-webdesign.de/cmsimpleplugins/?Nutzungsbedingungen">Commercial License</a> for commercial websites</li>
		<li>Internet: <a href="http://www.ge-webdesign.de/cmsimpleplugins/?Eigene_Plugins">www.ge-webdesign.de</a></li>
		</ul>
		';
	}
	
	if($admin=='plugin_main')
	{
		if(file_exists($pth['folder']['templates'].'__cmsimple_backend__/template.htm'))
		{
			$pth['folder']['template'] = $pth['folder']['templates'].'__cmsimple_backend__/';
			$pth['file']['template'] = $pth['folder']['template'].'template.htm';
			$pth['file']['stylesheet'] = $pth['folder']['template'].'stylesheet.css';
			$pth['folder']['menubuttons'] = $pth['folder']['template'].'menu/';
			$pth['folder']['templateimages'] = $pth['folder']['template'].'images/';
			$cf['meta']['robots'] = 'noindex, nofollow';
		}

//		$cjsDataPath = './' . $plugin_cf['charts']['path_charts'];
		
		if(is_dir('./content/plugins/charts/'))
		{
			$cjsDataPath = './' . $plugin_cf['charts']['path_charts'];
		}
		else
		{
			$cjsDataPath = $pth['folder']['base'] . $plugin_cf['charts']['path_charts'];
		}

		// create charts array
		if($cjsChartsHandle = opendir($cjsDataPath))
		{
			while($cjsChart = readdir($cjsChartsHandle))
			{
				if(preg_match('/\.php/i',$cjsChart))
				{
					$cjsCharts[] = str_replace('.php','',$cjsChart);
					natcasesort($cjsCharts);
				}
			}
		} 
		
		if(isset($_POST['cjsSelectedChart']) && $_POST['cjsSelectedChart'] != '')
		{
			unset($_SESSION['cjs_active_chart']);
			$_SESSION['cjs_active_chart'] = $_POST['cjsSelectedChart'];
		}
		
		if(isset($_POST['cjsSelectedChart']) && $_POST['cjsSelectedChart'] == $plugin_tx['charts']['text_select_chart'])
		{
			unset($_SESSION['cjs_active_chart']);
		}
		
		$o.='<p><b>Charts - ' . $plugin_tx['charts']['menu_main'] . '</b></p>';

		
/* 
#####################################
        begin backend output
##################################### 
*/

		if(isset($_POST['cjsNewChartFilename']) || isset($_POST['cjsActiveChart']))csrfProtection();

		if(!isset($_POST['cjsNewChartFilename']) && !isset($_GET['cjsDeleteChart']))
		{
			// chart selectbox
			if(!isset($_SESSION['cjs_active_chart']))
			{
				$o.='<p>' . $plugin_tx['charts']['text_newchart_hint'] . '</p>' . "\n";
			}
			
			$o.='<form method="post" action="?charts&admin=plugin_main&action=plugin_text&amp;cjsSelectedChart">' . "\n";
			$o.='<input type="hidden" name="csrf_token" value="' . $_SESSION[$csrfSession] . '">' . "\n";
			$o.='<select name="cjsSelectedChart" onchange="this.form.submit()" style="border: 2px solid #999; padding: 2px;">' . "\n";
			$o.='<option style="padding: 0 6px;">' . $plugin_tx['charts']['text_select_chart'] . '</option>' . "\n";
			
			foreach ($cjsCharts as $cjsSelectedChart)
			{
				if(isset($_SESSION['cjs_active_chart']) && $cjsSelectedChart == $_SESSION['cjs_active_chart'])
				{
					$o.='<option selected="selected" style="padding: 0 6px;" value="' . $cjsSelectedChart . '">' . $cjsSelectedChart . '</option>' . "\n";
				}
				else
				{
					$o.='<option style="padding: 0 6px;" value="' . $cjsSelectedChart . '">' . $cjsSelectedChart . '</option>' . "\n";
				}
			}
			$o.='</select>' . "\n";
			$o.='</form>' . "\n";
		
		
			// message selected chart
			if
			(
				!isset($_SESSION['cjs_active_chart']) || 
				isset($_SESSION['cjsSelectedChart']) && $_POST['cjsSelectedChart'] == $plugin_tx['charts']['text_select_chart'] || 
				$_SESSION['cjs_active_chart'] == $plugin_tx['charts']['text_select_chart']
			)
			{
				$o .='<p class="cjs_admin_no_chart_selected">' . $plugin_tx['charts']['text_nochart'] . '</p>' . "\n";
			}
			else
			{
				$o .='<p class="cjs_admin_selected_chart">' . $plugin_tx['charts']['message_active_chart1'] . '<span style="font-size: 20px;">&nbsp;&nbsp;' . $_SESSION['cjs_active_chart'] . '&nbsp;&nbsp;</span>' . $plugin_tx['charts']['message_active_chart2'] . '</p>' . "\n";
			}
		}
		
		$o .='<br style="clear: both;">';
		
		
		if(isset($_SESSION['cjs_active_chart']))
		{
			if(!isset($_POST['cjsNewChartFilename']) && !isset($_GET['cjsDeleteChart']) && !isset($_GET['cjs_write_data']))
			{
				if(isset($_POST['cjsNewChartFilename']))csrfProtection();
				
				// form create new chart
				$o.= '<h4>' . $plugin_tx['charts']['headline_create_new_chart'] . '</h4>
	<p>' . $plugin_tx['charts']['text_create_new_chart'] . '</p>
	<form method="post" action="' . $sn . '?charts&admin=plugin_main&action=plugin_text&cjs_create_chart=done&securityCode=' . $_SESSION[$csrfSession] . '">
	<p>' . $plugin_tx['charts']['text_chart_filename'] . '</p>
	<input type="hidden" name="csrf_token" value="' . $_SESSION[$csrfSession] . '">' . "\n" . '
	<input type="text" name="cjsNewChartFilename" style="float: left; width: 200px; font-family: arial, sans-serif; border: 1px solid #999; padding: 3px 6px;" />
	<input type="submit" class="submit" value="' . $plugin_tx['charts']['button_create_chart'] . '" />
	</form>';
			
			
				// link to delete chart
				if($plugin_cf['charts']['allow_delete_charts'] == 'true')
				{
					$o.= '<h4>' . $plugin_tx['charts']['headline_delete_chart'] . '</h4>
<p><a href="./?charts&admin=plugin_main&action=plugin_text&cjsDeleteChart&securityCode=' . $_SESSION[$csrfSession] . '" onClick="return confirm(\'' . $plugin_tx['charts']['text_confirm_delete_chart1'] . ' &nbsp; &quot;' . $_SESSION['cjs_active_chart'] . '&quot; &nbsp; ' . $plugin_tx['charts']['text_confirm_delete_chart2'] . '\')">' . $plugin_tx['charts']['text_delete_chart1'] . ' <b>"' . $_SESSION['cjs_active_chart'] . '"</b> ' . $plugin_tx['charts']['text_delete_chart2'] . ' &raquo;</a></p>
';
				}
			}
			
			// textarea data file
			if(!isset($_REQUEST['cjs_write_data']) && !isset($_REQUEST['cjs_create_chart'])  && !isset($_REQUEST['cjsDeleteChart']))
			{
				$o .='
	<hr>
	<h4>' . $plugin_tx['charts']['headline_edit_chart'] . '</h4>
	<form method="post" action="' . $sn . '?charts&admin=plugin_main&action=plugin_text&cjs_write_data=done">' . "\n" . '
	<input type="hidden" name="csrf_token" value="' . $_SESSION[$csrfSession] . '">' . "\n" . '
	<input type="submit" class="submit" style="margin-bottom: 12px;" value="' . $plugin_tx['charts']['button_save'] . '" /><br>
	<textarea type="text" class="cjsBackendDatafile" name="cjsActiveChart">' . file_get_contents($cjsDataPath . $_SESSION['cjs_active_chart'] . '.php') . '</textarea><br>' . "\n" . '
	<input type="submit" class="submit" value="' . $plugin_tx['charts']['button_save'] . '" />
	</form>' . "\n";
			}
		}
		
		
		// link to chartjs website
		if(!isset($_REQUEST['cjs_write_data']) && !isset($_REQUEST['cjs_create_chart'])  && !isset($_REQUEST['cjsDeleteChart']) && isset($_SESSION['cjs_active_chart']))
		{
			$o .='
<p>' . $plugin_tx['charts']['text_help'] . '</p>
<p><a href="https://www.chartjs.org/docs/latest/configuration/" target="_blank"><b>chartjs Website &raquo;</b></a></p>
<hr>';


		// show active chart
		$o .='
<div style="width: 60%; min-width: 320px; max-width: 600px; float: left; padding-right: 36px;">
' . cjsChart($_SESSION['cjs_active_chart']) . '
</div>
';


		}
/* 
#####################################
          write data file
##################################### 
*/

		if(isset($_POST['cjsActiveChart']))
		{
			if(!is_writeable($cjsDataPath . $_SESSION['cjs_active_chart'] . '.php'))
			{
				die('<p>The file</p><p style="font-family: courier new, monospace; font-weight: 700;">' . $cjsDataPath . $_SESSION['cjs_active_chart'] . '.php' . '</p><p>is not writeable, please check the writing permissions of the file.</p>');
			}
			else
			{
				$cjsDataFile = fopen($cjsDataPath . $_SESSION['cjs_active_chart'] . '.php', 'w+');
				ftruncate($cjsDataFile, 0);
				$cjsDatafileContent=$_POST['cjsActiveChart'];
				fwrite($cjsDataFile, $cjsDatafileContent);
				fclose($cjsDataFile);
			}
		}
		
		
/* 
#####################################
     create and delete charts
##################################### 
*/
		
		if(isset($_GET['cjs_create_chart']) && isset($_POST['cjsNewChartFilename']) && $_POST['cjsNewChartFilename'] != '')
		{
			if($_GET['securityCode'] == $_SESSION[$csrfSession])
			{
				copy($cjsDataPath . $_SESSION['cjs_active_chart'] . '.php',$cjsDataPath . $_POST['cjsNewChartFilename'] . '.php');
				chmod($cjsDataPath . $_POST['cjsNewChartFilename'] . '.php', 0666);
			}
			else
			{
				die("<a href=\"./?logout\">CSRF protection - logout &raquo;</a>");
			}
		}
		
		if(isset($_GET['cjsDeleteChart']))
		{
			if($_GET['securityCode'] == $_SESSION[$csrfSession])
			{
				unlink($cjsDataPath . $_SESSION['cjs_active_chart'] . '.php');
				unset($_SESSION['cjs_active_chart']);
			}
			else
			{
				die("<a href=\"./?logout\">CSRF protection - logout &raquo;</a>");
			}
		}
		
		
/* 
#####################################
     success messages
##################################### 
*/

		// success message updated data
		if(isset($_REQUEST['cjs_write_data']) && $_REQUEST['cjs_write_data'] == 'done')
		{
			$o.= '<p class="cmsimplecore_warning" style="text-align: center; font-weight: 700; line-height: 2em;">' . $plugin_tx['charts']['message_updated'] . '</p><br />';
			$o.= '<p style="text-align: center;">
<a href="./?charts&admin=plugin_main&action=plugin_text">' . $plugin_tx['charts']['message_back_mainfuncs'] . '</a></p>
<p style="text-align: center;">
';
		}
		
		// success message created chart
		if(isset($_REQUEST['cjs_create_chart']) && $_REQUEST['cjs_create_chart'] == 'done')
		{
			if(isset($_POST['cjsNewChartFilename']) && $_POST['cjsNewChartFilename'] != '')
			{
				$o.= '<p class="cmsimplecore_warning" style="text-align: center; font-weight: 700; line-height: 2em;">' . $plugin_tx['charts']['message_chart_created'] . '</p><br />';
				$o.= '<p style="text-align: center;">
<a href="./?charts&admin=plugin_main&action=plugin_text">' . $plugin_tx['charts']['message_back_mainfuncs'] . '</a></p>
<p style="text-align: center;">
';
			$_SESSION['cjs_active_chart'] = $_POST['cjsNewChartFilename'];
			}
			else
			{
				$o.= '<p class="cmsimplecore_warning" style="text-align: center; font-weight: 700; line-height: 2em;">' . $plugin_tx['charts']['message_no_chart_created'] . '</p><br />';
				$o.= '<p style="text-align: center;">
<a href="./?charts&admin=plugin_main&action=plugin_text">' . $plugin_tx['charts']['message_back_mainfuncs'] . '</a></p>
<p style="text-align: center;">
';
			}
		}
		
		// success message dleted chart
		if(isset($_REQUEST['cjsDeleteChart']))
		{
			$o.= '<p class="cmsimplecore_warning" style="text-align: center; font-weight: 700; line-height: 2em;">' . $plugin_tx['charts']['message_chart_deleted'] . '</p><br />';
			$o.= '<p style="text-align: center;">
<a href="./?charts&admin=plugin_main&action=plugin_text">' . $plugin_tx['charts']['message_back_mainfuncs'] . '</a></p>
<p style="text-align: center;">
';
		}
	}

	if ($admin <> 'plugin_main') 
	{
		$hint=array();
		$hint['mode_donotshowvarnames'] = false;
		$o.=plugin_admin_common($action, $admin, $plugin, $hint);
	}
}

?>